module Main where

import Lib
import System.Environment(getArgs)
import GHC.Base (VecElem(Int16ElemRep))
import System.IO.Error(catchIOError, isUserError, ioeGetFileName, isDoesNotExistError)
import System.Exit(die)

main :: IO ()
main = do
    [inpFile, kStr, destFile] <- getArgs
    let k = read kStr::Int
    runner inpFile (k-1) destFile

  `catchIOError` \ e -> die $ case ioeGetFileName e of
    _       | isUserError e -> "Usage: autocomplete <dict-filename> <k> <broken-filename>"
            | otherwise -> show e
