import Data.Map as M
import qualified Lib as L
import Data.Trie as T

t1 :: [[Char]] -> [[Char]] -> [Char]
t1 w res = if res == L.wordCleaner w then "t1 passed" else "t1 failed"

t2 :: (Foldable t, Ord k) => t k -> [(k, Int)] -> [Char]
t2 w res = if res == (M.toList (L.mapWordsSeq w)) then "t2 passed" else "t2 failed"

t3 :: Ord a => [[Char]] -> Trie a -> Int -> [[Char]] -> p -> p -> p
t3 ws trie k res tex1 tex2 = if res == (L.completeWords ws k trie ) then tex1 else tex2

main :: IO ()
main = do
    print(t1 ["*ab", "HelLo", "world"] ["ab", "hello", "world"])
    print(t2 ["hi", "hi"] [("hi", 2)])

    let trie = L.trieBuilder [("youre", 1), ("a", 1), ("wizard", 2), ("wizards", 1), ("harry", 3), ("hardware", 1)]
    print(t3 ["youre", "a", "wiz", "har"] trie 0 ["youre", "a", "wizard", "harry"] "t3 passed" "t3 failed")
    print(t3 ["youre", "a", "wiz", "har"] trie 1 ["youre", "a", "wizards", "hardware"] "t4 passed" "t4 failed")